package com.example.bpa.view.control;

import android.app.Activity;
import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Switch;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.example.bpa.Model.IWriteCallBack;
import com.example.bpa.Model.Res_PLCADDRESS;
import com.example.bpa.Model.Res_ZDSF;
import com.example.bpa.R;
import com.example.bpa.config.ConfigName;
import com.example.bpa.config.DataBus;
import com.example.bpa.helper.MessageLog;
import com.example.bpa.helper.T;
import com.example.bpa.service.DeviceData;
import com.example.bpa.view.from.lsjy_activity;
import com.example.bpa.view.mode.AlertLogEnum;

import java.util.List;

public class clsf_control  extends LinearLayout {
    private View root;

    TextView td_text;//标题
    Switch switch1;
    EditText bc_text1,bc_text2,bc_text3,bc_text4;
    Res_ZDSF sf;

    Button save_botton,cl_botton;
    int index;
    public clsf_control(Context context, @Nullable AttributeSet attrs, int i, Res_ZDSF zdsf,Activity activity) {
        super(context, attrs);
        root= LayoutInflater.from(context).inflate(R.layout.wrapanl_sfbc_item, this);
        td_text=this.findViewById(R.id.td_text);
        switch1=this.findViewById(R.id.switch1);

        bc_text1=this.findViewById(R.id.bc_text1);
        bc_text2=this.findViewById(R.id.bc_text2);
        bc_text3=this.findViewById(R.id.bc_text3);
        bc_text4=this.findViewById(R.id.bc_text4);
        save_botton=this.findViewById(R.id.save_botton);
        cl_botton=this.findViewById(R.id.cl_botton);
        index=i;
        sf=zdsf;
        Init(activity,i);
    }

    public void Init(Activity activity,int in)
    {
        //初始化数据
        td_text.setText(sf.name);

        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    activity.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            try {
                                switch1.setChecked(DeviceData.Get().getAutomationValue(in-1));
                                bc_text1.setText(DeviceData.Get().ReadAutomationValue(sf.H_address)+"");
                                bc_text2.setText(DeviceData.Get().ReadAutomationValue(sf.L_address)+"");

                                int time=DeviceData.Get().ReadAutomationValue(sf.time_address);
                                bc_text3.setText(String.format ("%.1f", time/10.0)+"");
                            } catch (Exception e) {

                            }
                        }
                    });
                } catch (Exception e) {

                }
            }
        }).start();

        switch1.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                boolean isopen= switch1.isChecked();
                if (DataBus.getInstance().PlcIsConnect)
                {
                    DeviceData.Get().writeAutomationSwitch(sf.kg_address,isopen);
                    T.show(view.getContext(), sf.name.toString()+(isopen?"打开":"关闭")+"成功!");

                }else
                {
                    T.show(view.getContext(), sf.name.toString()+(isopen?"打开":"关闭")+"失败!PLC未连接！！");
                }
            }
        });

        save_botton.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                Short H=0;
                Short L=0;
                Short time=0;
                try {
                    H=Short.parseShort(bc_text1.getText().toString()) ;
                    L=Short.parseShort(bc_text2.getText().toString()) ;
                    //time=(Short)Math.round();
                   int ftime = (int)Math.round((Double.parseDouble(bc_text3.getText().toString()) * 10));
                   time=(short) ftime;
                }
                catch (Exception ex)
                {

                }
                DeviceData.Get().writeAutomationValue(sf.H_address,H);
                DeviceData.Get().writeAutomationValue(sf.L_address,L);
                Boolean K= DeviceData.Get().writeAutomationValue(sf.time_address,time);

                if(K)
                {
                    T.show(view.getContext(), sf.name.toString()+",保存变量成功!");
                }else
                {
                    T.show(view.getContext(), sf.name.toString()+",保存变量失败!");

                }

            }
        });

        /**
         * 模拟出料
         */
        cl_botton.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                String zltext = bc_text4.getText().toString();
                if (zltext.equals("")) {
                    T.show(view.getContext(), "出料重量不能为空！");
                    return;
                }
                double zl = 0;
                try {
                    zl = Double.parseDouble(zltext);
                } catch (Exception e) {
                    T.show(view.getContext(), "出料重量获取异常！" + e.getMessage());
                    return;
                }

                if(zl<=1)
                {
                    T.show(view.getContext(), "出料重量至少大于1g！");
                    return;
                }

                double finalZl = zl;
                //将其余料仓出料设置为0,重置
                for (int k = 1; k <= 13; k++) {
                    if (k!=index) {
                        DeviceData.Get().setDemandValue((short) 0, k,null);
                    }
                }
                DeviceData.Get().setDemandValue((short) ((int)(zl*10)), index, new IWriteCallBack() {
                    @Override
                    public void onSuccess() {

                        MessageLog.ShowInfo( "模拟物料下发成功！克数："+ finalZl +"g");
                        T.show(view.getContext(), "模拟物料下发成功！克数："+ finalZl +"g");
                        DeviceData.Get().setChargeMixtureStart(new IWriteCallBack() {
                            @Override
                            public void onSuccess() {
                                MessageLog.ShowInfo( "开始出料！克数："+ finalZl +"g");
                                T.show(view.getContext(), "开始出料！克数："+ finalZl +"g");
                            }
                            @Override
                            public void onFailure(String ErrorMsg) {
                                MessageLog.ShowInfo( "出料失败！克数："+ finalZl +"g");
                                T.show(view.getContext(), "出料失败！克数："+ finalZl +"g");
                            }
                        });
                    }

                    @Override
                    public void onFailure(String ErrorMsg) {
                        MessageLog.ShowInfo( "模拟物料下发失败！");
                    }
                });
            }
        });
    }
}
