package com.example.bpa.view.from;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Switch;
import android.widget.TextView;

import com.example.bpa.Model.IWriteCallBack;
import com.example.bpa.R;
import com.example.bpa.config.ConfigName;
import com.example.bpa.helper.ActiveMax;
import com.example.bpa.helper.MessageLog;
import com.example.bpa.service.DeviceData;
import com.example.bpa.config.DataBus;
import com.example.bpa.helper.T;
import com.example.bpa.view.mode.UserLogEnum;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
 * 流速校验
 */
public class lsjy_activity extends AppCompatActivity implements View.OnClickListener {
    //region 变量
    /**
     * 返回按钮
     */
    ImageView gongneng_fanhui;
    /**
     * 标题设置
     */
    TextView gongneng_title;
    //通道校准值
    EditText passwayText_1, passwayText_2, passwayText_3, passwayText_4, passwayText_5, passwayText_6, passwayText_7, passwayText_8, passwayText_9, passwayText_10, passwayText_11, passwayText_12, passwayText_13;
    //校准基准时间
    EditText timeText;
    List<EditText> editTextLists = new ArrayList<EditText>();
    //通道校准开关
    Switch Switch_1, Switch_2, Switch_3, Switch_4, Switch_5, Switch_6, Switch_7, Switch_8, Switch_9, Switch_10, Switch_11, Switch_12, Switch_13;
    List<Switch> switchLists = new ArrayList<Switch>();
    //开始校准
    Button StartButton;
    //保存
    Button SaveButton;
    //清零
    Button ClearText;

    Button savecanshu;
    //重量
    TextView zhongliang;

    EditText bc_text4;
    Button cl_botton;

    //endregion

    //region 私有函数
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ActiveMax.MaxFrom(this);//最大化
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_lsjy);
        Init();
        initEvents();
        Initdata();
        Run();
    }

    @Override
    protected void onDestroy() {

        try {
            //设置自动模式
            DeviceData.Get().setHandOrAutoSwitch(true, null);
        } catch (Exception e) {

        }
        super.onDestroy();
    }

    //endregion

    //region 公共函数

    /**
     * 初始化
     */
    private void Init() {
        gongneng_fanhui = this.findViewById(R.id.gongneng_fanhui);
        gongneng_title = this.findViewById(R.id.gongneng_title);
        //通过Activity.getIntent()获取当前页面接收到的Intent。 getXxxExtra方法获取Intent传递过来的数据
        String msg = getIntent().getStringExtra("data");
        gongneng_title.setText(msg);
        //校准数值
        passwayText_1 = findViewById(R.id.passwayText_1);
        passwayText_2 = findViewById(R.id.passwayText_2);
        passwayText_3 = findViewById(R.id.passwayText_3);
        passwayText_4 = findViewById(R.id.passwayText_4);
        passwayText_5 = findViewById(R.id.passwayText_5);
        passwayText_6 = findViewById(R.id.passwayText_6);
        passwayText_7 = findViewById(R.id.passwayText_7);
        passwayText_8 = findViewById(R.id.passwayText_8);
        passwayText_9 = findViewById(R.id.passwayText_9);
        passwayText_10 = findViewById(R.id.passwayText_10);
        passwayText_11 = findViewById(R.id.passwayText_11);
        passwayText_12 = findViewById(R.id.passwayText_12);
        passwayText_13 = findViewById(R.id.passwayText_13);

        editTextLists = Arrays.asList(passwayText_1, passwayText_2, passwayText_3, passwayText_4, passwayText_5, passwayText_6, passwayText_7, passwayText_8, passwayText_9, passwayText_10, passwayText_11, passwayText_12, passwayText_13);

        //校准开关
        Switch_1 = findViewById(R.id.Switch_1);
        Switch_2 = findViewById(R.id.Switch_2);
        Switch_3 = findViewById(R.id.Switch_3);
        Switch_4 = findViewById(R.id.Switch_4);
        Switch_5 = findViewById(R.id.Switch_5);
        Switch_6 = findViewById(R.id.Switch_6);
        Switch_7 = findViewById(R.id.Switch_7);
        Switch_8 = findViewById(R.id.Switch_8);
        Switch_9 = findViewById(R.id.Switch_9);
        Switch_10 = findViewById(R.id.Switch_10);
        Switch_11 = findViewById(R.id.Switch_11);
        Switch_12 = findViewById(R.id.Switch_12);
        Switch_13 = findViewById(R.id.Switch_13);
        switchLists = Arrays.asList(Switch_1, Switch_2, Switch_3, Switch_4, Switch_5, Switch_6, Switch_7, Switch_8, Switch_9, Switch_10, Switch_11, Switch_12, Switch_13);

        //校准按钮
        StartButton = findViewById(R.id.StartButton);
        timeText = findViewById(R.id.edi_time);
        SaveButton = findViewById(R.id.savetime);

        savecanshu = findViewById(R.id.savecanshu);

        ClearText = findViewById(R.id.ClearText);
        zhongliang = findViewById(R.id.zhongliang);

        bc_text4=this.findViewById(R.id.bc_text4);
        cl_botton=this.findViewById(R.id.cl_botton);
    }

    /**
     * 初始化按钮事件
     */
    private void initEvents() {
        gongneng_fanhui.setOnClickListener(this);
        StartButton.setOnClickListener(this);
        SaveButton.setOnClickListener(this);
        ClearText.setOnClickListener(this);
        savecanshu.setOnClickListener(this);
        cl_botton.setOnClickListener(this);
    }

    /**
     * 初始化数据加载
     */
    public void Initdata() {
        //初始化标准值数据
        try {
            for (int i = 0; i < 13; i++) {
                String s = String.valueOf(DeviceData.Get().getCalibrationValue(i + 1));
                editTextLists.get(i).setText(String.format("%.1f", (Double.parseDouble(s) / 10)));
            }
            String time = String.valueOf(DeviceData.Get().getCalibrationReferenceTime());
            //校准时间
            timeText.setText(String.format("%.1f", (Double.parseDouble(time) / 10)));

            //设置手动模式
            DeviceData.Get().setHandOrAutoSwitch(false, null);
        } catch (Exception e) {

        }
    }
    //endregion

    //region 点击事件
    private boolean isClicked = false;

    /**
     * 本页面点击事件监听
     *
     * @param v
     */
    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.gongneng_fanhui://返回按钮
                this.finish();
                break;
            case R.id.savetime://校准基准时间保存
                // 执行操作
                if (!isClicked) {
                    isClicked = true;
                    SaveButton.setEnabled(false); // 禁用按钮防止重复点击
                    // 在2秒后执行按钮操作
                    new Handler().postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            // 执行按钮操作
                            // TODO: 在这里添加你的代码
                            try {
                                String stime = timeText.getText().toString();
                                if (stime.equals("")) {
                                    T.show(lsjy_activity.this, "校准基准时间不能为空！");
                                    return;
                                }
                                int ftime = 0;
                                try {
                                    ftime = (int) Math.round((Double.parseDouble(stime) * 10));
                                } catch (Exception e) {
                                    T.show(lsjy_activity.this, "校准基准时间异常！" + e.getMessage());
                                    return;
                                }

                                DeviceData.Get().setCalibrationReferenceTime((short) ftime, new IWriteCallBack() {
                                    @Override
                                    public void onSuccess() {
                                    }

                                    @Override
                                    public void onFailure(String ErrorMsg) {
                                    }
                                });
                            } catch (WindowManager.BadTokenException ex) {
                                MessageLog.ShowInfo("校准保存配置异常:" + ex.getMessage());
                            }
                            T.show(lsjy_activity.this, "时间写入成功");

                            SaveButton.setEnabled(true); // 恢复按钮状态
                            isClicked = false; // 重置点击状态
                        }
                    }, 500);
                }
                break;
            case R.id.StartButton://开始校准
                if (!isClicked) {
                    isClicked = true;
                    StartButton.setEnabled(false); // 禁用按钮防止重复点击
                    DeviceData.Get().setHandOrAutoSwitch(false, null);

                    // 在2秒后执行按钮操作
                    new Handler().postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            // 执行按钮操作
                            // TODO: 在这里添加你的代码
                            try {
                                //写开关状态 数值
                                for (int i = 0; i < 13; i++) {
                                    //1.写入开关状态
                                    DeviceData.Get().setChCalibrationSwitch(switchLists.get(i).isChecked(), i + 1, new IWriteCallBack() {
                                        @Override
                                        public void onSuccess() {
                                        }

                                        @Override
                                        public void onFailure(String ErrorMsg) {
                                        }
                                    });
                                }
                                //写开始校准
                                DeviceData.Get().setChStartCalibration(new IWriteCallBack() {
                                    @Override
                                    public void onSuccess() {
                                        T.show(lsjy_activity.this, "通道开始校准");
                                    }

                                    @Override
                                    public void onFailure(String ErrorMsg) {
                                        T.show(lsjy_activity.this, "通道开始校准失败");
                                    }
                                });
                            } catch (Exception ex) {
                                MessageLog.ShowInfo("开始校准异常:" + ex.getMessage());
                            }


                            StartButton.setEnabled(true); // 恢复按钮状态
                            isClicked = false; // 重置点击状态
                        }
                    }, 100);
                }
                break;
            case R.id.ClearText://清空称重重量
                DeviceData.Get().setWeightClear(new IWriteCallBack() {
                    @Override
                    public void onSuccess() {
                        T.show(lsjy_activity.this, "清零成功");
                    }

                    @Override
                    public void onFailure(String ErrorMsg) {
                        T.show(lsjy_activity.this, "清零失败");
                    }
                });
                break;
            case R.id.savecanshu://保存数字
                // 执行操作
                if (!isClicked) {
                    isClicked = true;
                    savecanshu.setEnabled(false); // 禁用按钮防止重复点击
                    // 在2秒后执行按钮操作
                    new Handler().postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            // 执行按钮操作
                            // TODO: 在这里添加你的代码
                            try {
                                for (int i = 0; i < 13; i++) {
                                    if (switchLists.get(i).isChecked() == true)//校准开关打开后,允许校准
                                    {
                                        String value = editTextLists.get(i).getText().toString();
                                        Short val = 0;
                                        try {
                                            val = (short) Math.round((Double.parseDouble(value) * 10));
                                        } catch (Exception e) {
                                        }
                                        if (val <= 0) {
                                            T.show(lsjy_activity.this, "请检查[通道" + (i + 1) + "]数值不能小于0");
                                            return;
                                        }
                                    }
                                }
                                //写开关状态 数值
                                for (int i = 0; i < 13; i++) {
                                    String value = editTextLists.get(i).getText().toString();
                                    Short val = 0;
                                    try {
                                        val = (short) Math.round((Double.parseDouble(value) * 10));
                                    } catch (Exception e) {
                                    }

                                    final boolean[] IsComplete = {false};
                                    DeviceData.Get().setCalibrationValue(val, i + 1, new IWriteCallBack() {
                                        @Override
                                        public void onSuccess() {
                                            IsComplete[0] = true;
                                        }

                                        @Override
                                        public void onFailure(String ErrorMsg) {
                                            IsComplete[0] = true;
                                        }
                                    });

                                    long a = System.currentTimeMillis();
                                    while (!IsComplete[0]) {
                                        if ((System.currentTimeMillis() - a) > 1000 * 6) {
                                            break;
                                        }
                                        Thread.sleep(100);//10 *6
                                    }
                                }
                            } catch (WindowManager.BadTokenException ex) {
                                MessageLog.ShowInfo("校准保存配置异常:" + ex.getMessage());
                            } catch (InterruptedException ex) {
                                MessageLog.ShowInfo("校准保存配置异常:" + ex.getMessage());
                            }
                            T.show(lsjy_activity.this, "参数值写入成功");
                            savecanshu.setEnabled(true); // 恢复按钮状态
                            isClicked = false; // 重置点击状态
                        }
                    }, 500);
                }
                break;
            case R.id.cl_botton:
                String zltext = bc_text4.getText().toString();
                if (zltext.equals("")) {
                    T.show(lsjy_activity.this, "出料重量不能为空！");
                    return;
                }
                double zl = 0;
                try {
                    zl = Double.parseDouble(zltext);
                } catch (Exception e) {
                    T.show(lsjy_activity.this, "出料重量获取异常！" + e.getMessage());
                    return;
                }

                if(zl<=1)
                {
                    T.show(lsjy_activity.this, "出料重量至少大于1g！");
                    return;
                }

                int index=-1;
                for (int i = 0; i < 13; i++) {
                    if (switchLists.get(i).isChecked() == true)//校准开关打开后,允许校准
                    {
                        if(index<=-1)
                        {
                            index=i+1;
                        }
                    }
                }

                if (index<=0)
                {
                    T.show(lsjy_activity.this, "请打开通道开关！");
                    return;
                }
                DeviceData.Get().setHandOrAutoSwitch(true, null);

                double finalZl = zl;
                //将其余料仓出料设置为0,重置
                for (int k = 1; k <= 13; k++) {
                    if (k!=index) {
                        DeviceData.Get().setDemandValue((short) 0, k,null);
                    }
                }
                DeviceData.Get().setDemandValue((short) ((int)(zl*10)), index, new IWriteCallBack() {
                    @Override
                    public void onSuccess() {

                        MessageLog.ShowInfo( "模拟物料下发成功！克数："+ finalZl +"g");
                        T.show(lsjy_activity.this, "模拟物料下发成功！克数："+ finalZl +"g");
                        DeviceData.Get().setChargeMixtureStart(new IWriteCallBack() {
                            @Override
                            public void onSuccess() {
                                MessageLog.ShowInfo( "开始出料！克数："+ finalZl +"g");
                                T.show(lsjy_activity.this, "开始出料！克数："+ finalZl +"g");
                            }
                            @Override
                            public void onFailure(String ErrorMsg) {
                                MessageLog.ShowInfo( "出料失败！克数："+ finalZl +"g");
                                T.show(lsjy_activity.this, "出料失败！克数："+ finalZl +"g");
                            }
                        });
                    }

                    @Override
                    public void onFailure(String ErrorMsg) {
                        MessageLog.ShowInfo( "模拟物料下发失败！");
                    }
                });
                break;
        }
    }
    //endregion

    //region 线程

    /**
     * 实时显示线程
     */
    public void Run() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (DataBus.getInstance().PlcIsConnect) {
                    try {
                        lsjy_activity.this.runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                try {
                                    zhongliang.setText(String.valueOf(DeviceData.Get().getCallCurrentWeight(1) / 10.0) + " g");
                                } catch (Exception e) {
                                    MessageLog.ShowInfo("重量解析显示异常！" + e.getMessage());
                                }
                            }
                        });
                        Thread.sleep(500);
                    } catch (InterruptedException e) {
                        throw new RuntimeException(e);
                    }
                }
            }
        }).start();
    }
    //endregion
}