package com.example.bpa.view.from;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.example.bpa.R;
import com.example.bpa.config.ConfigName;
import com.example.bpa.db.QueryDB;
import com.example.bpa.db.mode.BPA_MATERIAL;
import com.example.bpa.db.mode.BPA_MENU;
import com.example.bpa.helper.ActiveMax;
import com.example.bpa.helper.T;
import com.example.bpa.view.adapter.pflb_adapter;
import com.example.bpa.view.adapter.wl_adapter;
import com.example.bpa.view.inteface.MyClickListener;

import java.util.ArrayList;

public class pflb_activity extends AppCompatActivity implements View.OnClickListener, MyClickListener {

    //region 变量
    /**
     * 返回按钮
     */
    ImageView gongneng_fanhui;
    /**
     * 标题设置
     */
    TextView gongneng_title;

    //endregion

    //region 操作变量
    /**
     * 输入框
     */
    TextView edittext;
    /**
     * 增加按钮
     */
    Button buttonadd;
    /**
     * 表格显示
     */
    ListView datatab;
    /**
     * 配方类别数据
     */
    ArrayList<BPA_MENU> data=new ArrayList<>();
    //endregion

    //region 私有函数
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ActiveMax.MaxFrom(this);//最大化
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pflb);
        Init();
        initEvents();
    }
    //endregion

    //region 公共函数

    /**
     * 初始化
     */
    private void Init(){
        gongneng_fanhui = this.findViewById(R.id.gongneng_fanhui);
        gongneng_title = this.findViewById(R.id.gongneng_title);
        edittext= this.findViewById(R.id.edittext);
        buttonadd= this.findViewById(R.id.buttonadd);
        datatab= this.findViewById(R.id.datatab);
        //通过Activity.getIntent()获取当前页面接收到的Intent。 getXxxExtra方法获取Intent传递过来的数据
        String msg=getIntent().getStringExtra("data");
        gongneng_title.setText("配方分组");
        Initdata();
    }

    /**
     * 初始化按钮事件
     */
    private void initEvents() {
        gongneng_fanhui.setOnClickListener(this);
        buttonadd.setOnClickListener(this);
        edittext.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View view, int i, KeyEvent keyEvent) {
                return false;
            }
        });
    }

    /**
     * 初始化数据加载
     */
    public void Initdata()
    {
        try{
            data= QueryDB.GetMenuALL();
            pflb_adapter adapter = new pflb_adapter(pflb_activity.this, R.layout.wl_item, data,this);
            datatab.setAdapter(adapter);
        }catch(Exception e){

        }
    }
    //endregion

    //region 点击事件
    /**
     * 本页面点击事件监听
     *
     * @param v
     */
    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.gongneng_fanhui://返回按钮
                this.finish();
                break;
            case R.id.buttonadd://增加按钮点击
                String name= edittext.getText().toString();
                if(name.isEmpty()){
                    T.show(this, "物料名称不能为空!");
                    return;
                }
                if(QueryDB.GetMenuIs(name)){
                    T.show(this, "名称重复,请重新输入后重试!");
                    return;
                }
                BPA_MENU bpa_material=new BPA_MENU();
                bpa_material.name=name;
                bpa_material.deviceID= ConfigName.getInstance().DeviceId;
                bpa_material.userID=ConfigName.getInstance().user.userID;
                QueryDB.AddMenu(bpa_material);
                T.show(this, "新增成功!");
                Initdata();
                break;
        }
    }

    /**
     * 接口方法，响应ListView按钮点击事件
     */
    @Override
    public void clickListener(View v,Object data) {
        switch (v.getId())
        {
            case R.id.button_item://删除按钮
                QueryDB.DeleteMenu((BPA_MENU)data);
                Initdata();
                T.show(this, "删除成功!");
                break;
            case R.id.button_item_update://修改按钮
                QueryDB.UpdateMenu((BPA_MENU)data);
                Initdata();
                T.show(this, "修改成功!");
                break;
        }
    }
    //endregion
}